public hook_say_team(id)
{
	if(is_user_hltv(id) || is_user_bot(id))
	{
		return PLUGIN_CONTINUE
	}
	if(is_user_gaged(id))
	{
		return PLUGIN_HANDLED
	}
	read_args(s_Msg, 255)
	remove_quotes(s_Msg)
	if(is_plugin_cmd(s_Msg))
	{
		return PLUGIN_CONTINUE
	}
	if(is_empty_message(s_Msg))
	{
		return PLUGIN_HANDLED
	}
	if(is_system_message(s_Msg))
	{
		if(get_pcvar_num(g_IgnoreMode) == 1)
		{
			SlashFound = true
		}
		else if(get_pcvar_num(g_IgnoreMode) == 2)
		{
			return PLUGIN_HANDLED
		}
		else if(get_pcvar_num(g_IgnoreMode) == 3)
		{
			return PLUGIN_CONTINUE
		}
	}
	else
	{
		SlashFound = false
	}
	get_time("20%y.%m.%d", p_LogFileTime, 31)
	get_time("%H:%M:%S", p_LogTime, 31)
	if(get_pcvar_num(g_Cheat) == 1 && is_cheat_message(id, s_Msg))
	{
		client_punish(id, PUNISH_CHEAT)
		return PLUGIN_HANDLED
	}
	if(get_pcvar_num(g_Spam) && is_spam_message(id, s_Msg))
	{
		SpamFound[id]++
		if(SpamFound[id]-1 >= get_pcvar_num(g_SpamWarns))
		{
			SpamFound[id] = 0
			client_punish(id, PUNISH_SPAM)
		}
		else
		{
			format(Info, 191, "^x04[%s] ^x01%L", PLUGIN, LANG_PLAYER, "CT_SPAMWARN", get_pcvar_num(g_SpamWarns) - SpamFound[id])
			WriteMessage(id, Info)
			if(get_pcvar_num(g_Sounds))
			{
				client_cmd(id, "spk buttons/blip2")
			}
		}
		return PLUGIN_HANDLED
	}
	if(get_pcvar_num(g_Ignore) && is_ignored_message(s_Msg))
	{
		if(get_pcvar_num(g_IgnoreMode) == 1)
		{
			IgnoreFound = true
		}
		else if(get_pcvar_num(g_IgnoreMode) == 2)
		{
			return PLUGIN_HANDLED
		}
		else if(get_pcvar_num(g_IgnoreMode) == 3)
		{
			return PLUGIN_CONTINUE
		}
	}
	else
	{
		IgnoreFound = false
	}
	StrTeam = get_user_team(id)
	ReplaceSwear(255, s_Msg)
	if(get_pcvar_num(g_Translit) && !IgnoreFound)
	{
		get_user_info(id, "translit", s_Info, 1)
		if(equal(s_Info, "1") || get_pcvar_num(g_AutoRus) == 2)
		{
			for(new i; i < i_MaxSimbols; i++)
			{
				if(contain(s_SwearMsg, g_OriginalSimb[i]) != -1)
				{
					replace_all(s_SwearMsg, 255, g_OriginalSimb[i], g_TranslitSimb[i])
				}
			}
			for(new i; i < i_MaxSimbols; i++)
			{
				if(contain(s_Msg, g_OriginalSimb[i]) != -1)
				{
					replace_all(s_Msg, 255, g_OriginalSimb[i], g_TranslitSimb[i])
				}
			}
		}
	}
	get_user_name(id, s_Name, 31)
	if(get_user_flags(id) & NICK_LEVEL && get_pcvar_num(g_AdminPrefix))
	{
		format(StrName, 127, "[%L] %s", LANG_PLAYER, "CT_ADMIN", s_Name)
	}
	else
	{
		format(StrName, 127, "%s", s_Name)
	}
	get_user_team(id, AliveTeam, 31)
	if(equal(AliveTeam, "TERRORIST"))
	{
		format(p_Team, 31, "(%L)", LANG_PLAYER, "CT_TERRORIST")
		format(p_LogTeam, 63, "<font color=^"#FFB41E^">(%L) <font>", LANG_PLAYER, "CT_TERRORIST")
	}
	else if(equal(AliveTeam, "CT"))
	{
		format(p_Team, 31, "(%L)", LANG_PLAYER, "CT_CT")
		format(p_LogTeam, 63, "<font color=^"#FFB41E^">(%L) </font>", LANG_PLAYER, "CT_CT")
	}
	else if(equal(AliveTeam, "SPECTATOR"))
	{
		format(p_Team, 31, "(%L)", LANG_PLAYER, "CT_SPECTATOR2")
		format(p_LogTeam, 63, "<font color=^"#FFB41E^">(%L) </font>", LANG_PLAYER, "CT_SPECTATOR2")
	}
	if(is_user_alive(id))
	{
		isAlive = 1
		format(Alive, 31, "^x01")
		format(p_LogAlive, 31, "")
	}
	else if(!is_user_alive(id) && !equal(AliveTeam,"SPECTATOR"))
	{
		isAlive = 0
		format(Alive, 31, "^x01*%L* ", LANG_PLAYER, "CT_DEAD")
		format(p_LogAlive, 127, "<font color=^"#FFB41E^">*%L* </font>", LANG_PLAYER, "CT_DEAD")
	}
	else if(!is_user_alive(id) && equal(AliveTeam,"SPECTATOR"))
	{
		isAlive = 0
		format(Alive, 31, "^x01*%L* ", LANG_PLAYER, "CT_SPECTATOR")
		format(p_LogAlive, 127, "<font color=^"#FFB41E^">*%L* </font>", LANG_PLAYER, "CT_SPECTATOR")
	}
	static color[10]
	if(get_user_flags(id) & NICK_LEVEL)
	{
		switch(get_pcvar_num(g_NameColor))
		{
			case 1:
			{
				format(p_Name, 255, "%s%s %s", Alive, p_Team, StrName)
				format(p_LogName, 511, "%s%s<font color=^"#FFB41E^">%s</font>", p_LogAlive, p_LogTeam, StrName)
			}
			case 2:
			{
				format(p_Name, 255, "%s%s ^x04%s", Alive, p_Team, StrName)
				format(p_LogName, 511, "%s%s<font color=^"green^">%s</font>", p_LogAlive, p_LogTeam, StrName)
			}
			case 3:
			{
				color = "SPECTATOR"
				format(p_Name, 255, "%s%s ^x03%s", Alive, p_Team, StrName)
				format(p_LogName, 511, "%s%s<font color=^"gray^">%s</font>", p_LogAlive, p_LogTeam, StrName)
			}
			case 4:
			{
				color = "CT"
				format(p_Name, 255, "%s%s ^x03%s", Alive, p_Team, StrName)
				format(p_LogName, 511, "%s%s<font color=^"blue^">%s</font>", p_LogAlive, p_LogTeam, StrName)
			}
			case 5:
			{
				color = "TERRORIST"
				format(p_Name, 255, "%s%s ^x03%s", Alive, p_Team, StrName)
				format(p_LogName, 511, "%s%s<font color=^"red^">%s</font>", p_LogAlive, p_LogTeam, StrName)
			}
			case 6:
			{
				get_user_team(id, color, 9)
				format(p_Name, 255, "%s%s ^x03%s", Alive, p_Team, StrName)
				if(equal(color, "CT"))
				{
					format(p_LogName, 511, "%s%s<font color=^"blue^">%s</font>", p_LogAlive, p_LogTeam, StrName)
				}
				if(equal(color, "TERRORIST"))
				{
					format(p_LogName, 511, "%s%s<font color=^"red^">%s</font>", p_LogAlive, p_LogTeam, StrName)
				}
				if(equal(color, "SPECTATOR"))
				{
					format(p_LogName, 511, "%s%s<font color=^"gray^">%s</font>", p_LogAlive, p_LogTeam, StrName)
				}
			}
		}
		switch(get_pcvar_num(g_ChatColor))
		{
			case 1:
			{
				format(p_Message, 255, "%s", s_Msg)
				format(p_LogMsg, 511, "<font color=^"#FFB41E^">%s</font>", s_Msg)
			}
			case 2:
			{
				format(p_Message, 255, "^x04%s", s_Msg)
				format(p_LogMsg, 511, "<font color=^"green^">%s</font>", s_Msg)
			}
			case 3:
			{
				copy(color, 9, "SPECTATOR")
				format(p_Message, 191, "^x03%s", s_Msg)
				format(p_LogMsg, 511, "<font color=^"gray^">%s</font>", s_Msg)
			}
			case 4:
			{
				copy(color, 9, "CT")
				format(p_Message, 255, "^x03%s", s_Msg)
				format(p_LogMsg, 511, "<font color=^"blue^">%s</font>", s_Msg)
			}
			case 5:
			{
				copy(color, 9, "TERRORIST")
				format(p_Message, 255, "^x03%s", s_Msg)
				format(p_LogMsg, 511, "<font color=^"red^">%s</font>", s_Msg)
			}
			case 6:
			{
				get_user_team(id, TeamColor, 9)
				copy(color, 9, TeamColor)
				format(p_Message, 255, "^x03%s", s_Msg)
				if(equal(TeamColor, "CT"))
				{
					format(p_LogMsg, 511, "<font color=^"blue^">%s</font>", s_Msg)
				}
				if(equal(TeamColor, "TERRORIST"))
				{
					format(p_LogMsg, 511, "<font color=^"red^">%s</font>", s_Msg)
				}
				if(equal(TeamColor, "SPECTATOR"))
				{
					format(p_LogMsg, 511, "<font color=^"gray^">%s</font>", s_Msg)
				}
			}
		}
	}
	else
	{
		get_user_team(id, color, 9)
		format(p_Name, 255, "%s%s ^x03%s", Alive, p_Team, StrName)
		format(p_Message, 255, "%s", s_Msg)
		if(equal(color, "CT"))
		{
			format(p_LogName, 511, "%s%s<font color=^"blue^">%s</font>", p_LogAlive, p_LogTeam, StrName)
		}
		if(equal(color, "TERRORIST"))
		{
			format(p_LogName, 511, "%s%s<font color=^"red^">%s</font>", p_LogAlive, p_LogTeam, StrName)
		}
		if(equal(color, "SPECTATOR"))
		{
			format(p_LogName, 511, "%s%s<font color=^"gray^">%s</font>", p_LogAlive, p_LogTeam, StrName)
		}
		format(p_LogMsg, 511, "<font color=^"#FFB41E^">%s</font>", s_Msg)
	}
	if(get_pcvar_num(g_SwearFilter))
	{
		new iSwear = is_swear_message(id, s_SwearMsg)
		if(iSwear)
		{
			SwearFound = true
			if(get_pcvar_num(g_SwearGag))
			{
				s_ChatEnable[id] = "OFF"
				Flood[id] = "OFF"
				SysTime = get_systime(0)
				i_Gag[id] = SysTime + get_pcvar_num(g_SwearTime)*60
				get_user_name(id, s_GagName[id], 31)
				get_user_ip(id, s_GagIp[id], 31, 1)
				format(Info, 191, "^x04[%s] ^x01%L", PLUGIN, LANG_PLAYER, "CT_SWEAR_GAG", get_pcvar_num(g_SwearTime))
				WriteMessage(id, Info)
				set_task(0.0, "enable_chat", id)
				if(get_pcvar_num(g_Log) == 1)
				{
					format(p_LogDir, 63, "%s/colored_translit", p_FilePath)
					format(p_LogFile, 127, "%s/gag_%s.log", p_LogDir, p_LogFileTime)
					if(!dir_exists(p_LogDir))
					{
						mkdir(p_LogDir)
					}
					get_user_ip(id, p_LogIp, 31, 1)
					format(p_LogMessage, 1023, "%s - Swear Filter has gaged %s <%s> for %d minutes. Message: %s. Found: %s", p_LogTime, s_GagName[id], p_LogIp, get_pcvar_num(g_SwearTime), s_SwearMsg, Swear[iSwear - 1])
					write_file(p_LogFile, p_LogMessage)
				}
			}
			format(p_Message, 191, "%s", Replace[random(ReplaceNum)])
			if(get_pcvar_num(g_Sounds))
			{
				client_cmd(id, "spk buttons/blip2")
			}
		}
	}
	else
	{
		SwearFound = false
	}
	format(Message, 511, "%s ^x01: %s", p_Name, p_Message)
	if(strlen(Message) >= 192)
	{
		format(Info, 191, "^x04[%s] ^x01%L", PLUGIN, LANG_PLAYER, "CT_LONGMSG")
		WriteMessage(id, Info)
		return PLUGIN_HANDLED
	}
	SendTeamMessage(color, isAlive, StrTeam)
	if(get_pcvar_num(g_Log))
	{
		format(p_LogDir, 63, "%s/colored_translit", p_FilePath)
		format(p_LogFile, 127, "%s/chat_%s.htm", p_LogDir, p_LogFileTime)
		if(!dir_exists(p_LogDir))
		{
			mkdir(p_LogDir)
		}
		if(!file_exists(p_LogFile))
		{
			format(p_LogTitle, 511, "<title>Colored Ctranslit Chat Log v2.0 Final by Sho0ter - %s</title>%s", p_LogFileTime, LOGTITLE)
			write_file(p_LogFile, p_LogTitle)
			write_file(p_LogFile, LOGFONT)
		}
		get_user_ip(id, p_LogIp, 31, 1)
		get_user_authid(id, p_LogSteamId, 31)
		format(p_LogInfo, 511, "<font color=^"black^">%s &lt;%s&gt;&lt;%s&gt;</font>", p_LogTime, p_LogSteamId, p_LogIp)
		format(p_LogMessage, 1023, "%s %s : %s<br>", p_LogInfo, p_LogName, p_LogMsg)
		write_file(p_LogFile, p_LogMessage)
	}
	if(!SwearFound || get_pcvar_num(g_SwearGag) != 1)
	{
		s_ChatEnable[id] = "OFF"
		get_user_name(id, s_GagName[id], 31)
		SysTime = get_systime(0)
		i_Gag[id] = SysTime + get_pcvar_num(g_FloodTime)
		Flood[id] = "ON"
		set_task(get_pcvar_float(g_FloodTime)+1.0, "enable_chat", id)
	}
	return PLUGIN_HANDLED
}